import java.util.*;
import java.io.*;
import java.lang.*;

class Oppgave1d{
    short [][] U; // 0: unvisited, 1: true, 2: false
    int[] result;
    int n,K;
    int[] input;
    Scanner in;
    PrintWriter out;
    public static void main(String[] args){
	new Oppgave1d(args);
    }
    
    // recursive search
    public boolean search(int nleft, int sum){
	// if finished searching
	if (nleft == 0){
	    if (sum == 0){
		U[nleft][sum] = 1;
		return true;
	    }
	    U[nleft][sum] = 2;
	    return false;
	}
	if (U[nleft][sum]!=0)          // if visited
	    return (U[nleft][sum]==1); // return value == true

	// try to remove current number
	if (sum>=input[nleft-1] && search(nleft-1,sum-input[nleft-1])){
	    U[nleft][sum] = 1;
	    return true;
	}
	// don't remove current number
	else if(search(nleft-1,sum)){
	    U[nleft][sum] = 1;
	    return true;
	}
	// this didn't work, store result and return false
	U[nleft][sum] = 2;
	return false;
    } 

    // search for a way to nleft==0, such that the sum goes to 0. Then
    // print out on the way back. 
    public void backtrack(int nleft,int sum){
	if (nleft==0) return;
	// if we can go up, go up (don't use the number)
	if (U[nleft-1][sum] == 1){
	    backtrack(nleft-1,sum);
	    out.print("("+input[nleft-1]+",0)");
	}
	// use the number
	else{
	    backtrack(nleft-1,sum-input[nleft-1]);
	    out.print("("+input[nleft-1]+",1)");
	}
    }

    // initialize and read input
    public Oppgave1d(String[] args){
	try{
	    in = new Scanner(new FileReader(args[0]));
	}
	catch(Exception e){
	    in = new Scanner(System.in);
	}
	try{
	    out = new PrintWriter(new File(args[1]));
	}
	catch(Exception e){
	    out = new PrintWriter(System.out);
	}
	try{
	    n = in.nextInt();
	    K = in.nextInt();
	    input = new int[n];
	    for (int i=0;i<n;i++){
		input[i] = in.nextInt();
	    }
	}
	catch(Exception e){
	    System.out.println(e);
	}
	U = new short[n+1][K+1];
	for (int i=0;i<n+1;i++){
	    for (int j=0;j<K+1;j++){
		U[i][j]=0;
	    }
	}
	if (!search(n,K))
	    out.println("NEI");
	else{
	    out.print("JA "+K+" ");
	    backtrack(n,K);
	}

	try{
	    out.close();
	    in.close();
	}
	catch(Exception e){
	    e.printStackTrace();
	}
    }
}
