import java.util.*;
import java.io.*;
import java.lang.*;

class Oppgave1e{
    // The key in the map is the sum (0-K), and the object is the
    // maximum set of input numbers that _doesn't_ sum up to the key.
    //
    // memo.get(8) == 3 --> any subset of the first 3 (or fewer)
    // numbers does not sum up to 8. But the first 4 (or more) input
    // numbers MIGHT.
    HashMap<Integer,Integer> memo;
    int n,K;
    int[] input;
    Scanner in;
    PrintWriter out;
    public static void main(String[] args){
	new Oppgave1e(args);
    }
    
    // recursive search
    public boolean searchAndPrint(int sum,int nleft){
	// if finished searching
	if (nleft == 0){
	    // if successful, return true, and start printing
	    if (sum == 0){
		out.print("JA "+K+" ");
		return true;
	    }
	    // not successful
	    return false;
	}
	// search further
	nleft--;
	// already tried this, didn't work
	if (memo.containsKey(sum) && memo.get(sum)>=nleft)
	    return false;
	// try to remove current number
	if (sum>=input[nleft] && searchAndPrint(sum-input[nleft],nleft)){
	    // it was successful, print result, and return true to
	    // print further
	    out.print("("+input[nleft]+",1)");
	    return true;
	}
	// don't remove current number
	else if(searchAndPrint(sum,nleft)){
	    // successful, print and return true
	    out.print("("+input[nleft]+",0)");
	    return true;
	}
	// this didn't work, store the result
	memo.put(sum,nleft);
	return false;
    } 

    // initialize and read input
    public Oppgave1e(String[] args){
	try{
	    in = new Scanner(new FileReader(args[0]));
	}
	catch(Exception e){
	    in = new Scanner(System.in);
	}
	try{
	    out = new PrintWriter(new File(args[1]));
	}
	catch(Exception e){
	    out = new PrintWriter(System.out);
	}
	try{
	    n = in.nextInt();
	    K = in.nextInt();
	    input = new int[n];
	    for (int i=0;i<n;i++){
		input[i] = in.nextInt();
	    }
	}
	catch(Exception e){
	    System.out.println(e);
	}
	memo = new HashMap<Integer,Integer>();
	if (!searchAndPrint(K,n))
	    out.println("NEI");
	try{
	    out.close();
	    in.close();
	}
	catch(Exception e){
	    e.printStackTrace();
	}
    }
}
